/*
Computer Graphics Programming in OpenGL with Java, 2nd Edition, V. Scott Gordon, John Clevenger
Page 28 and page 19.
*/

import static com.jogamp.opengl.GL4.*;
import com.jogamp.opengl.*;
import com.jogamp.opengl.awt.GLJPanel;

import javax.swing.*;

public class Code_5a extends JFrame implements GLEventListener
{
   private final GLJPanel myCanvas;
   private final int[] vao = new int[1];
   private int renderingProgram;

   public Code_5a()
   {
      this.setTitle("Chapter 2 - program 5a (Code_5a)");
      this.setSize(600, 400);
      myCanvas = new GLJPanel();
      myCanvas.addGLEventListener(this);
      this.add(myCanvas);
      this.setLocationRelativeTo(null);
      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      this.setVisible(true);
   }


   public void init(GLAutoDrawable drawable)
   {
      final GL4 gl = (GL4) GLContext.getCurrentGL();

      gl.glClearColor(0.8f, 0.8f, 0.8f, 1.0f);

      gl.glGenVertexArrays(vao.length, vao, 0);
      gl.glBindVertexArray(vao[0]);

      renderingProgram = Utils.createShaderProgram("shaders/vertShader_5.glsl",
                                                   "shaders/fragShader_5a.glsl");
   }


   public void display(GLAutoDrawable drawable)
   {
      final GL4 gl = (GL4) GLContext.getCurrentGL();

      gl.glClear(gl.GL_COLOR_BUFFER_BIT | gl.GL_DEPTH_BUFFER_BIT);

      gl.glUseProgram(renderingProgram);
      gl.glDrawArrays(GL_TRIANGLES, 0, 3);
   }

   public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h){}
   public void dispose(GLAutoDrawable drawable){}


   public static void main(String[] args)
   {
      new Code_5a();
   }
}
