/*
Computer Graphics Programming in OpenGL with Java, 2nd Edition, V. Scott Gordon, John Clevenger
Page 34.
*/

import static com.jogamp.opengl.GL4.*;
import com.jogamp.opengl.*;
import com.jogamp.opengl.awt.GLJPanel;

import javax.swing.*;

public class Code_7 extends JFrame implements GLEventListener
{
   private final GLJPanel myCanvas;

   public Code_7()
   {
      this.setTitle("Chapter 2 - supplemental notes (Code_7)");
      this.setSize(100, 100);
      myCanvas = new GLJPanel();
      myCanvas.addGLEventListener(this);
      this.add(myCanvas);
      this.setLocationRelativeTo(null);
      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      this.setVisible(true);
   }

   public void init(GLAutoDrawable drawable)
   {
      GL4 gl = (GL4) GLContext.getCurrentGL();

      final int[]   sizeI = new int[2];
      final float[] sizeF = new float[2];

      gl.glGetIntegerv(GL_MAX_TEXTURE_IMAGE_UNITS, sizeI, 0);
      gl.glGetFloatv(GL_POINT_SIZE_RANGE, sizeF, 0);

      System.out.printf("GL_MAX_TEXTURE_IMAGE_UNITS: %d %d\n", sizeI[0], sizeI[1]);
      System.out.printf("GL_POINT_SIZE_RANGE: %f %f\n", sizeF[0], sizeF[1]);
   }

   public void display(GLAutoDrawable drawable){}
   public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h){}
   public void dispose(GLAutoDrawable drawable){}

   public static void main(String[] args)
   {
      new Code_7();
   }
}
